'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _prod = require('../webpack-v3/prod');

var _prod2 = _interopRequireDefault(_prod);

var _getConfig = require('../helpers/get-config');

var _getConfig2 = _interopRequireDefault(_getConfig);

var _webpackMerge = require('webpack-merge');

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

var _preview = require('../preview');

var _preview2 = _interopRequireDefault(_preview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var build = function build(argv) {
  var root = argv.root,
      srcPath = argv.srcPath,
      distPath = argv.distPath,
      vendor = argv.vendor,
      enableHTMLPlugin = argv.enableHTMLPlugin,
      port = argv.port,
      webpackConfig = argv.webpackConfig,
      viewServer = argv.viewServer;

  var init = _prod2.default.getInitProdConfig({
    root,
    srcPath,
    distPath,
    vendor,
    enableHTMLPlugin
  });
  var config = (0, _webpackMerge2.default)(init, (0, _getConfig2.default)(webpackConfig));
  (0, _webpack2.default)(config, function (err, stats) {
    if (err) throw err;
    var info = stats.toJson();
    if (stats.hasErrors()) {
      info.errors.map(function (errMsg) {
        console.error(errMsg, '\n\r');
      });
    } else {
      if (viewServer) {
        (0, _preview2.default)(port);
      }
    }
  });
};
exports.default = build;