'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevMiddleware = require('webpack-dev-middleware');

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _dev = require('../webpack-v3/dev');

var _dev2 = _interopRequireDefault(_dev);

var _getConfig = require('../helpers/get-config');

var _getConfig2 = _interopRequireDefault(_getConfig);

var _webpackMerge = require('webpack-merge');

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var start = function start(argv) {
  var root = argv.root,
      srcPath = argv.srcPath,
      distPath = argv.distPath,
      vendor = argv.vendor,
      enableHTMLPlugin = argv.enableHTMLPlugin,
      devServer = argv.devServer,
      port = argv.port,
      webpackConfig = argv.webpackConfig;

  var init = _dev2.default.getInitDevConfig({
    root,
    srcPath,
    distPath,
    vendor,
    enableHTMLPlugin,
    devServer
  });
  var config = (0, _webpackMerge2.default)(init, (0, _getConfig2.default)(webpackConfig));
  var compiler = (0, _webpack2.default)(config);
  var server = (0, _express2.default)();
  server.use((0, _webpackDevMiddleware2.default)(compiler, {
    logLevel: 'debug',
    logTime: true
  }));
  server.listen(port);
};
exports.default = start;