'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _default = require('../default');

var _default2 = _interopRequireDefault(_default);

var _path = require('path');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackMerge = require('webpack-merge');

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

var _htmlWebpackPlugin = require('html-webpack-plugin');

var _htmlWebpackPlugin2 = _interopRequireDefault(_htmlWebpackPlugin);

var _autodllWebpackPlugin = require('autodll-webpack-plugin');

var _autodllWebpackPlugin2 = _interopRequireDefault(_autodllWebpackPlugin);

var _cleanWebpackPlugin = require('clean-webpack-plugin');

var _cleanWebpackPlugin2 = _interopRequireDefault(_cleanWebpackPlugin);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _optimizeCssAssetsWebpackPlugin = require('optimize-css-assets-webpack-plugin');

var _optimizeCssAssetsWebpackPlugin2 = _interopRequireDefault(_optimizeCssAssetsWebpackPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var packageCss = new _extractTextWebpackPlugin2.default('styles/package_[hash].css');
var selfCss = new _extractTextWebpackPlugin2.default('styles/self_[hash].css');
var getInitProdConfig = function getInitProdConfig(_ref) {
  var root = _ref.root,
      srcPath = _ref.srcPath,
      distPath = _ref.distPath,
      publicPath = _ref.publicPath,
      vendor = _ref.vendor,
      enableHTMLPlugin = _ref.enableHTMLPlugin;

  root = root || _default2.default.root;
  srcPath = srcPath || _default2.default.srcPath;
  distPath = distPath || _default2.default.distPath;
  publicPath = publicPath || _default2.default.publicPath;
  enableHTMLPlugin = enableHTMLPlugin || _default2.default.enableHTMLPlugin;
  var config = (0, _webpackMerge2.default)(_common2.default, {
    context: (0, _path.resolve)(root, srcPath),
    entry: {
      app: './index.js'
    },
    output: {
      filename: 'scripts/init/[name]-[hash].js',
      chunkFilename: 'scripts/chunks/[name]-[chunkhash].js',
      publicPath: publicPath,
      path: (0, _path.resolve)(root, distPath)
    },
    module: {
      rules: [{
        test: /\.js$/,
        loader: 'babel-loader',
        exclude: /node_modules/
      }, {
        test: /\.css$/,
        exclude: /node_modules/,
        use: selfCss.extract({
          fallback: 'style-loader',
          use: [{
            loader: 'css-loader',
            options: {
              sourceMap: true,
              modules: true,
              importLoaders: 0,
              localIdentName: '[name]_[local]'
            }
          }]
        })
      }, {
        test: /\.css$/,
        include: /node_modules/,
        use: packageCss.extract(['style-loader', 'css-loader'])
      }, {
        test: /\.(jpe?g|png|gif|svg|woff|woff2|eot|otf|ttf)$/i,
        use: [{
          loader: 'file-loader',
          options: {
            name: '[path]/[name]-[hash].[ext]',
            outputPath: 'assets/'
          }
        }]
      }]
    },
    devtool: 'source-map',
    plugins: [new _cleanWebpackPlugin2.default(['**/*.*'], {
      root: (0, _path.resolve)(root, distPath)
    }), new _webpack2.default.DefinePlugin({
      'process.env.NODE_ENV': JSON.stringify('production')
    }), packageCss, selfCss, new _optimizeCssAssetsWebpackPlugin2.default(), new _webpack2.default.optimize.UglifyJsPlugin({
      parallel: true
    })]
  });
  if (enableHTMLPlugin) {
    var options = Object.assign({}, {
      filename: 'index.html',
      template: './index.html'
    }, enableHTMLPlugin);
    config.plugins.unshift(new _htmlWebpackPlugin2.default(options));
  }
  if (Array.isArray(vendor)) {
    config.plugins.unshift(new _autodllWebpackPlugin2.default({
      filename: '[name]_[hash].js',
      inject: true,
      entry: {
        vendor: vendor
      },
      output: {
        publicPath: publicPath
      },
      plugins: [new _webpack2.default.DefinePlugin({
        'process.env.NODE_ENV': JSON.stringify('production')
      }), new _webpack2.default.optimize.UglifyJsPlugin()]
    }));
  }
  return config;
};
exports.default = {
  prodConfig: getInitProdConfig({}),
  getInitProdConfig
};