import webpack from 'webpack';
import prod from '../webpack-v3/prod';
import getConfig from '../helpers/get-config';
import merge from 'webpack-merge';
import preview from '../preview';
let build = (argv) => {
  let { root, srcPath, distPath, vendor, enableHTMLPlugin, port, webpackConfig, viewServer } = argv;
  let init = prod.getInitProdConfig({
    root,
    srcPath,
    distPath,
    vendor,
    enableHTMLPlugin
  });
  let config = merge(init, getConfig(webpackConfig));
  webpack(config, (err, stats) => {
    if(err) throw err;
    let info = stats.toJson();
    if(stats.hasErrors()){
      info.errors.map(errMsg => {
        console.error(errMsg,'\n\r');
      });
    }else{
      if(viewServer){
        preview(port);
      }
    }

  });
};
export default build;