import express from 'express';
import webpack from 'webpack';
import middleware from 'webpack-dev-middleware';
import dev from '../webpack-v3/dev';
import getConfig from '../helpers/get-config';
import merge from 'webpack-merge';
let start = (argv) => {
  let { root, srcPath, distPath, vendor, enableHTMLPlugin, devServer, port, webpackConfig } = argv;
  let init = dev.getInitDevConfig({
    root,
    srcPath,
    distPath,
    vendor,
    enableHTMLPlugin,
    devServer
  });
  let config = merge(init, getConfig(webpackConfig));
  let compiler = webpack(config);
  let server = express();
  server.use(middleware(compiler,{
    logLevel: 'debug',
    logTime: true
  }));
  server.listen(port);
};
export default start;